package com.sooka.sponest.event.centereventtforestfireloss.controller;

import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.utils.StringUtils;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.sooka.sponest.event.centereventtfireinformation.domain.FireInformation;
import com.sooka.sponest.event.centereventtfireinformation.service.ICentereventTFireInformationService;
import com.sooka.sponest.event.centereventtforestfireloss.domain.VisuForestFireLossVO;
import com.sooka.sponest.event.centereventtforestfireloss.service.ICentereventTForestFireLossService;
import com.sooka.sponest.event.centereventtregionalflag.service.ICentereventTRegionalFlagService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.collections4.MapUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 火灾损失Controller
 *
 * @author lyq
 * @date 2023-1-31
 */
@Api(tags = "火灾损失")
@RestController
@RequestMapping("/centereventtforestfireloss")
public class CentereventTForestFireLossController extends BaseController {

    @Autowired
    private ICentereventTForestFireLossService centereventTForestFireLossService;

    @Autowired
    private ICentereventTRegionalFlagService centereventTRegionalFlagService;

    @Autowired
    private ICentereventTFireInformationService centereventTFireInformationService;

    @ApiOperation("灾后评估")
    @PostMapping("/getFireLoss")
    public R getFireLoss(@RequestBody VisuForestFireLossVO visuForestFireLossVO) {
        Map<String, Object> resultMap = new HashMap<>();
        if (StringUtils.isBlank(visuForestFireLossVO.getId())) {
            resultMap.put("visuForestFireLossBO", centereventTForestFireLossService.getFireLoss(visuForestFireLossVO));
            List<Map<String, Object>> list = centereventTForestFireLossService.getFireList(visuForestFireLossVO);
            resultMap.put("visuForestFireLossTimeBOList", list);
            if (StringUtils.isNotEmpty(list)) {
                visuForestFireLossVO.setYear(null);
                visuForestFireLossVO.setId(MapUtils.getString(list.get(0), "id"));
                resultMap.put("visuForestFireLossBOFirst", centereventTForestFireLossService.getFireLoss(visuForestFireLossVO));
                resultMap.put("regionalFlagBOList", centereventTRegionalFlagService.getFireLocation(MapUtils.getString(list.get(0), "eventId")));
            }
        } else {
            resultMap.put("visuForestFireLossBO", centereventTForestFireLossService.getFireLoss(visuForestFireLossVO));
            resultMap.put("regionalFlagBOList", centereventTRegionalFlagService.getFireLocation(visuForestFireLossVO.getEventId()));
        }
        return R.ok(resultMap);
    }

    // 新增火险报告（火场资料）
    @PostMapping("/addFireInformationFeign")
    public AjaxResult addFireInformationFeign(@RequestBody FireInformation fireInformation) {
        return toAjax(centereventTFireInformationService.addFireInformation(fireInformation));
    }
}
